
/* Example of analysis of Phomopsis leaf blight for 1997		*/
/* using %GLIMMIX macro or GLIMMIX procedure					*/
/* trt: treatment; rep: block; su: sampling unit within plot;	*/
/* x: number of diseased leaflets; n: leaflet number			*/
/* 

/* The original article (Madden et al. 2002. PLANT DISEASE, 	*/
/* Vol. 86, pages 316-325) is based solely on the now 			*/
/* out of date %glimmix macro. With one exception, the new 		*/
/* procedure can do all the model fits, plus much more			*/

/* Read in data... Data strung across lines						*/

data phomop;
input trt rep su x n @@;
datalines;
 8 1 1   4  15  8 1 2  12  15  8 1 3  11  15  8 1 4  12  15 
 8 1 5   9  15  1 2 1   9  15  1 2 2   4  15  1 2 3   3  15 
 1 2 4   9  15  1 2 5   7  15  2 3 1   3  15  2 3 2   9  15 
 2 3 3   4  15  2 3 4   4  15  2 3 5   6  15  7 4 1   4  15 
 7 4 2   0  15  7 4 3   1  15  7 4 4   2  15  7 4 5   0  15 
 6 1 1   2  15  6 1 2   2  15  6 1 3   1  15  6 1 4   0  15 
 6 1 5   6  15  3 2 1   1  15  3 2 2   1  15  3 2 3   1  15 
 3 2 4   0  15  3 2 5   2  15  5 3 1   0  15  5 3 2   1  15 
 5 3 3   1  15  5 3 4   0  15  5 3 5   0  15  8 4 1   6  15 
 8 4 2   1  15  8 4 3   9  15  8 4 4   4  15  8 4 5   8  15 
 4 1 1   5  15  4 1 2   7  15  4 1 3   5  15  4 1 4   0  15 
 4 1 5   5  15  5 2 1   0  15  5 2 2   0  15  5 2 3   0  15 
 5 2 4   1  15  5 2 5   0  15  8 3 1  12  15  8 3 2   5  15 
 8 3 3   6  15  8 3 4   9  15  8 3 5   5  15  1 4 1   6  15 
 1 4 2  11  15  1 4 3   1  15  1 4 4   2  15  1 4 5   6  15 
 1 1 1   0  15  1 1 2   7  15  1 1 3   0  15  1 1 4   2  15 
 1 1 5   4  15  8 2 1   9  15  8 2 2   7  15  8 2 3   6  15 
 8 2 4   0  15  8 2 5   4  15  6 3 1   1  15  6 3 2   0  15 
 6 3 3   0  15  6 3 4   0  15  6 3 5   1  15  4 4 1   1  15 
 4 4 2   0  15  4 4 3   0  15  4 4 4   0  15  4 4 5   0  15 
 3 1 1   4  15  3 1 2   4  15  3 1 3   0  15  3 1 4   6  15 
 3 1 5   5  15  4 2 1   5  15  4 2 2   3  15  4 2 3   3  15 
 4 2 4   3  15  4 2 5   0  15  3 3 1   3  15  3 3 2   0  15 
 3 3 3   0  15  3 3 4   3  15  3 3 5   8  15  6 4 1   0  15 
 6 4 2   0  15  6 4 3   2  15  6 4 4   1  15  6 4 5   2  15 
 2 1 1   0  15  2 1 2   5  15  2 1 3   1  15  2 1 4   0  15 
 2 1 5   6  15  2 2 1   6  15  2 2 2   2  15  2 2 3   0  15 
 2 2 4   6  15  2 2 5   7  15  7 3 1   0  15  7 3 2   0  15 
 7 3 3   0  15  7 3 4   0  15  7 3 5   0  15  5 4 1   0  15 
 5 4 2   1  15  5 4 3   2  15  5 4 4   0  15  5 4 5   1  15 
 5 1 1   0  15  5 1 2   1  15  5 1 3   1  15  5 1 4   1  15 
 5 1 5   0  15  6 2 1   0  15  6 2 2   3  15  6 2 3   2  15 
 6 2 4   1  15  6 2 5   1  15  4 3 1   1  15  4 3 2   6  15 
 4 3 3   0  15  4 3 4   0  15  4 3 5   1  15  3 4 1   0  15 
 3 4 2   0  15  3 4 3   2  15  3 4 4   3  15  3 4 5   1  15 
 7 1 1   0  15  7 1 2   0  15  7 1 3   0  15  7 1 4   0  15 
 7 1 5   0  15  7 2 1   1  15  7 2 2   1  15  7 2 3   0  15 
 7 2 4   0  15  7 2 5   0  15  1 3 1   3  15  1 3 2   5  15 
 1 3 3   7  15  1 3 4   2  15  1 3 5   1  15  2 4 1   1  15 
 2 4 2   0  15  2 4 3   8  15  2 4 4   5  15  2 4 5  11  15 
;
/* The following statement tells SAS where to find %glimmix	*/
/* (you may have it in a different directory)				*/
/* Note: the macro may have several examples attached.		*/
/* Remove these examples and re-save the macro.				*/
/* You must obtain the macro directly from SAS (free)		*/

%INCLUDE 'C:\users\madden.1\My Documents\My SAS Files\glimmix.sas';

/* Model A					*/
/* See Piepho (1999) for a nice description of the SAS input.	*/
/* in addition to the REPL analysis, least squares means	*/
/* (estimated linear predictors) for TRT are calculated, as well 	*/
/* as pairwise differences (PDIFF)			*/
/* Note: COVTEST does a large-sample test for all estimated	*/
/* variance terms (probably not valid with typical sample sizes)	*/
/*
%glimmix(data =phomop, procopt=covtest,
		stmts=%str(title 'MODEL A, 1997';
		class trt rep su ;
		model x/n = trt  / solution chisq;
		random rep;
		random int / sub=trt*rep;
               		lsmeans trt / cl pdiff;
		),
	error=binomial, maxit=50,
	link=logit
); 
run;
*/
%glimmix(data =phomop, procopt=covtest,
		stmts=%str(title 'macro, MODEL A, 1997';
		class trt rep su ;
		model x/n = trt  / solution chisq;
		random rep;
		random int / sub=trt*rep;
               		lsmeans trt / cl pdiff;
		),
	error=binomial, maxit=50,
	link=logit
); 
run;

*---Easier, and better, to use the PROCedure....;

proc glimmix data=phomop maxopt=60 pconv=1e-6;
	title 'proc glimmix model A';
	class trt rep su;
	model x/n = trt /ddfm = satterth chisq dist=bin link=logit;
	random  rep trt*rep;
	random _residual_ / subject=trt*rep;
		*^--in PROC, one must explicitly give residual term for overdispersion;
	lsmeans trt /lines;
run;


%glimmix(data =phomop, procopt=covtest,
		stmts=%str(title 'macro, MODEL B, 1997';
		class trt rep su ;
		model x/n = trt  / solution chisq;
		random rep;
		random int su/ sub=trt*rep;
		parms (0.04) (0.03) (0.4) (1) /eqcons=4;
               		 lsmeans trt / cl pdiff;
		
		),
	error=binomial, maxit=50,
	link=logit
); 
run;

proc glimmix data=phomop maxopt=60 pconv=1e-6;
		title 'proc glimmix model B';
		class trt rep su ;
		model x/n = trt  / solution chisq;
		random rep;
		random int su/ sub=trt*rep;
		*^--in PROC, the SU random effect takes the place of residual;
		lsmeans trt / cl pdiff  lines ;
run;

*---Because the rep variance is estimated at 0, it is probably best to take out this 
	term for the model fits.;

